<template >
 

    <div align="center">

        <v-toolbar style="box-shadow:none !important">
            <v-toolbar-title>
            </v-toolbar-title>
            
            <div style="padding:35px">
              <br>
              <v-select 
                item-text="SERVER_CODE"
                item-value="SERVER_CODE"
                v-model="server_code"
                :items="list_server_code"
                label="Request item for server"
                style="width:150px"
                v-bind:value="{ id: SERVER_CODE, text: SERVER_CODE }"
                v-on:change="searchMaterial()"
              ></v-select>
            </div>
            <v-spacer></v-spacer> 

            <div style="margin-right:10px;cursor:pointer" v-on:click="listdraft()">
            
              <v-badge left style="margin-right:20px">
                  <template v-slot:badge>
                    <span style="margin-bottom:3px"><v-icon dark>mdi-basket-outline</v-icon></span>
                  </template>
                  <span style="font-size:15px" to="/listRegister">{{totalDraft}} Draft</span>
              </v-badge>

              <v-btn depressed color="primary" to="/listRegister">Registration List</v-btn>&nbsp;
                              
            </div>                
        </v-toolbar>

        <div align="center" style="width:50%;margin-top:70px">
              <v-img
                alt="Vuetify Name"
                class="shrink mt-1 hidden-sm-and-down"
                contain
                min-width="100"
                src="../../assets/logo-em2.png"
                width="210"
              />
              <br>
              <v-text-field style="font-size:16px"
                large
                rounded
                label="Solo"                         
                placeholder="Ketikan Item Name / Item Description / Part Number / Collaquial Name"
                solo
                height="60"
                v-model="search"
                append-icon="search"
                @click:append="searchMaterial()"
                v-on:keyup.enter="searchMaterial()"
              ></v-text-field>
              
              <v-progress-circular
                :width="3"
                color="primary"
                indeterminate
                v-if="loading"
              ></v-progress-circular>
               
        </div>
        
        <div style="width:95%;margin-bottom:80px" v-if="container" align="left">
            <div align="left">
                <v-card>
                  <div style="padding:15px 15px 0px 15px;font-size:18px">
                    Hasil Pencarian Item <b>{{reskey}}</b><br><br>
                  </div>
                    <div>
                        <v-toolbar style="box-shadow:none !important">
                           <v-checkbox
                            v-model="checkedServer"
                            style="margin-top:20px;margin-left:15px"
                            label="GEMS"
                            value="GEMS"
                            v-on:change="searchMaterial()"
                          ></v-checkbox>

                          <v-checkbox
                            v-model="checkedServer"
                            style="margin-top:20px;margin-left:15px"
                            label="BKES"
                            value="BKES"
                            v-on:change="searchMaterial()"
                          ></v-checkbox>

                          <v-checkbox
                            v-model="checkedServer"
                            style="margin-top:20px;margin-left:15px"
                            label="BC"
                            value="BC"
                            v-on:change="searchMaterial()"
                          ></v-checkbox>

                                      
                      </v-toolbar>
                    </div>
                    <template>
                      <div v-if="result==''" align="center" style="padding:30px">
                          Data tidak ditemukan
                      </div>
                      
                      <template>
                            <v-data-table
                              :headers="headers"
                              :items="desserts"
                              :items-per-page="15"
                              class="elevation-1"
                            >

                            <template v-slot:item.company="{ item }">
                                <v-tooltip bottom >
                                    <template v-slot:activator="{ on }">
                                      <span style="cursor:pointer" text small v-on="on" >
                                        {{item.COMPANY.substring(0,40)+"..."}}
                                      </span>
                                    </template>
                                    <div style="width:180px" >{{item.COMPANY}}</div>
                                  </v-tooltip>
                            </template>

                            <template v-slot:item.action="{ item }">
                                  <v-btn v-if="item.SERVER_CODE != server_select " small color="success" v-on:click="extended(item.MATERIAL_NUMBER)">
                                    <span style="font-uppercase:normal">Reg/Copy</span>
                                  </v-btn>

                                  <v-btn v-if="item.SERVER_CODE == server_select" disabled small color="success">
                                    <span>Available</span>
                                  </v-btn>  
                            </template>


                        </v-data-table>

                        
                      </template>

                      <v-simple-table v-if="result!=''">
                        <template v-slot:default>
                          <thead>
                            <tr>
                              <th class="text-left">Server</th>
                              <th class="text-left">Material Number</th>
                              <th class="text-left">INC Code</th>
                              <th class="text-left">Description</th>
                              <th class="text-left">Additional Info</th>
                              <th class="text-left">Colloquial</th>
                              <th class="text-left">Brand</th>
                              <th class="text-left">Part No.</th>
                              <th class="text-left">Company</th>
                              <th>Action</th>
                            </tr>
                          </thead> 
                          <tbody>
                            <tr v-for="item in result" v-bind:key="item.id">
                              <td>{{item.SERVER_CODE}}</td>
                              <td>{{item.MATERIAL_NUMBER}}</td>
                              <td>{{item.INC_CODE}}</td>
                              <td>{{item.DESCRIPTION}}</td>
                              <td class="text-left">{{item.ADDITIONAL_INFORMATION}}</td>
                              <td>{{item.COLLAQUAL_NAME}}</td>
                              <td class="text-left">{{item.BRAND}}</td>
                              <td class="text-left">{{item.PART_NO}}</td>
                              <td v-if="item.COMPANY" style="width:200px" v-on:click="getPlant(item.MATERIAL_NUMBER)">
                                  <v-tooltip bottom >
                                    <template v-slot:activator="{ on }">
                                      <span style="cursor:pointer" text small v-on="on" >
                                        {{item.COMPANY.substring(0,40)+"..."}}
                                      </span>
                                    </template>
                                    <div style="width:180px" >{{item.COMPANY}}</div>
                                  </v-tooltip>
                              </td>
                              <td v-if="!item.COMPANY">
                                Tidak ada perusahaan di material ini
                              </td>

                              <td v-if="item.COMPANY">
                                  <v-btn v-if="item.SERVER_CODE != server_select " small color="success" v-on:click="extended(item.MATERIAL_NUMBER)">
                                    <span style="font-uppercase:normal">Reg/Copy</span>
                                  </v-btn>

                                  <v-btn v-if="item.SERVER_CODE == server_select" disabled small color="success">
                                    <span>Available</span>
                                  </v-btn>  
                              </td>

                              <td v-if="!item.COMPANY">
                                Tidak ada perusahaan di material ini
                              </td>
                            </tr>
                          </tbody>
                        </template>
                      </v-simple-table>



                    </template>
                  </v-card>
            </div>

            <div align="right" style="padding-top:20px">                           
                    <v-btn large color="primary" retain-focus-on-click="true" v-on:click="newregister()">
                      <span class="mr-2">Register New Item</span>
                    </v-btn>
            </div>
        </div>

        <template>
          <v-dialog
              v-model="dialog_plant"
              max-height="600px"
              max-width="800px"
            >
              <v-card>
                <v-card-title>
                  Plant
                </v-card-title>
                <v-card-text>
                      <v-simple-table>
                        <template v-slot:default>
                          <thead> 
                            <tr>
                              <th class="text-left">Plant Code</th>
                              <th class="text-left">Plant Name</th>
                              <th class="text-left">Company Name</th>
                            </tr>
                          </thead>
                          <tbody>
                            <tr v-for="item in list_detail_plant" :key="item.plant">
                              <td>{{ item.PLANT }}</td>
                              <td>{{ item.PLANT_NAME }}</td>
                              <td>{{ item.COMPANY_NAME }}</td>
                            </tr>
                          </tbody>
                        </template>
                      </v-simple-table>
                </v-card-text>
                <v-card-actions>
                  <v-btn
                    color="primary"
                    text
                    @click="dialog_plant = false"
                  >
                    Close
                  </v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>

            
          </template>

          
    </div>

    
    
</template>


<script>
export default {
    methods: {
        searchMaterial(){      
            var self = this;
            var val = this.search;
            var url = this.base_url + 'search/initial_material';
            
            var server_code = self.server_code;
            if(server_code){
              self.server_select = server_code;
            }
            
            var arrserver = self.checkedServer;
            var server = "";
            
            for(var a=0; a<arrserver.length; a++){
                server += ",'"+arrserver[a]+"'";
            }

            server = server.substr(1)
            self.reskey = val;        
            
            if(arrserver.length < 1){
                server = "";
            }

            
            if(val){
              self.loading = true;
              self.container = false;

              this.axios.post(url , {
                  param : val,
                  server: server
              })
              .then(function (response) {
                  self.result = response.data;
                  self.desserts = response.data;
                  self.loading = false;
                  self.container = true;
              })
              .catch(function (error) {
                  self.result = error;
                  self.loading = false;
                  self.container = true;
              });
            }
        },
        extended(id){
            var server_code = this.server_code;
            this.$router.push({path: '/addRegister/'+server_code+'/extended/'+id});
        },
        newregister(){
          var server_code = this.server_code;
          this.$router.push({path: '/addRegister/'+server_code});
        },
        listdraft(){
            this.$router.push({path: '/listRegister/draft'});
        },
        check: function() {
          console(this.checkedServer)
        },
        getTotalDraft(){
          var self = this;
          var url  = self.base_url + "material/count";
          this.axios.post(url , {
              user_id : self.storage_user_id,
              status : 'DRAFT'
          })
          .then(function (response) {
              self.totalDraft = response.data[0].total;
          });
      },
      getServer(){
        var self = this;
        self.company_id = '';
        self.plant = '';
        self.storage_location = '';
        var url = this.base_url + "dropdown/server_setting/"+self.storage_user_id; 
        this.axios.get(url).then(function (response) {
          var list_server = JSON.parse(response.data[0].SERVER_ROLE);
          self.list_server_code = list_server;
          self.server_code = list_server[0];
        })
      },
      getPlant(material_number){
          var self = this;
          var url = this.base_url + "dropdown/plant_detail/"+material_number; 
          this.axios.get(url).then(function (response) {
            self.list_detail_plant = response.data;        
          });
          self.dialog_plant = true;
      }
    },
    mounted(){
      this.getTotalDraft();
      if(this.storage_role !='REQ'){
          this.$router.push('/login');
      }
      
      this.getServer();
      this.server_select = this.storage_server;
    },
    data () { 
      return {
        checkedServer: [],
        loading:false,
        search:"",
        reskey:"",
        company_name: "PT. BARASENTOSA LESTARI",
        name : "Registration",
        title : "Search Material",
        dialog: false,
        sound: true,
        widgets: false,
        container:false,
        selected: [],
        totalDraft:0,
        result: [],
        list_server_code : [],
        server_code:'',
        server_select:'',
        dialog_plant:false,
        list_detail_plant:[],


        headers: [
          { text: 'Material Number', value: 'MATERIAL_NUMBER',width:'170' },
          { text: 'INC Code', value: 'INC_CODE',width:'130' },
          { text: 'Description', value: 'DESCRIPTION',width:'130' },
          { text: 'Additional Info', value: 'ADDITIONAL_INFORMATION',width:'110' },
          { text: 'Collaqual Name', value: 'COLLAQUAL_NAME',width:'150' },
          { text: 'Brand', value: 'BRAND',width:'150' },
          { text: 'Part No', value: 'PART_NO',width:'150' },
          { text: 'Company', value: 'company', sortable: false,width:150},
          { text: 'Action', value: 'action', sortable: false,width:150},
        ],
        desserts: [],

        //storage.....................................
        storage_user_id : atob(localStorage.getItem("user_id")),
        storage_username : atob(localStorage.getItem("username")),
        storage_fullname : atob(localStorage.getItem("fullname")),
        storage_company_id : atob(localStorage.getItem("company_id")),
        storage_company_name : atob(localStorage.getItem("company_name")),
        storage_role : atob(localStorage.getItem("role")),
        storage_server : atob(localStorage.getItem("server")),
        departement_id : atob(localStorage.getItem("departement_id")),
        departement_desc : atob(localStorage.getItem("departement_desc"))
      }
    }
  }
</script>
